﻿using C1.Win.C1Tile;
using C1TileControl_RunTimeCS.Properties;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace C1TileControl_RunTimeCS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void CB_TileColor_SelectedIndexChanged(object sender, EventArgs e)
        {
            c1TileControl1.TileBackColor = Color.FromName(CB_TileColor.SelectedItem.ToString());
            c1TileControl1.Focus();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            c1TileControl1.CommonImage1.Image = global :: C1TileControl_RunTimeCS.Properties.Resources.Flags;
            c1TileControl1.CommonImage1.ImageRows = 17;

            C1.Win.C1Tile.ImageElement ImageElement1 = new C1.Win.C1Tile.ImageElement();
            ImageElement1.ImageSelector = C1.Win.C1Tile.ImageSelector.CommonImage1;
            ImageElement1.Margin = new System.Windows.Forms.Padding(0, 0, 0, 20);
            c1TileControl1.DefaultTemplate.Elements.Add(ImageElement1);

            PropertyMapping prop = new PropertyMapping();
            prop.DataField = "ID";
            prop.TileProperty = TileProperty.IntValue;
            c1TileControl1.PropertyMappings.Add(prop);

            prop = new PropertyMapping();
            prop.DataField = "Name";
            prop.TileProperty = TileProperty.Text;
            c1TileControl1.PropertyMappings.Add(prop);

            prop = new PropertyMapping();
            prop.DataField = "Group";
            prop.TileProperty = TileProperty.Group;
            c1TileControl1.PropertyMappings.Add(prop);

            DataTable dt = new DataTable();
            dt.Columns.Add("ID");
            dt.Columns.Add("Name");
            dt.Columns.Add("Group");
            dt.Rows.Add(1, "Value 1", "Group A");
            dt.Rows.Add(2, "Value 2", "Group A");
            dt.Rows.Add(3, "Value 3", "Group A");
            dt.Rows.Add(4, "Value 4", "Group A");
            dt.Rows.Add(5, "Value 5", "Group A");
            dt.Rows.Add(6, "Value 6", "Group B");
            dt.Rows.Add(7, "Value 7", "Group B");
            dt.Rows.Add(8, "Value 8", "Group B");
            dt.Rows.Add(9, "Value 9", "Group B");
            dt.Rows.Add(10, "Value 10", "Group B");
            dt.Rows.Add(11, "Value 11", "Group C");
            dt.Rows.Add(12, "Value 12", "Group C");
            dt.Rows.Add(13, "Value 13", "Group C");
            dt.Rows.Add(14, "Value 14", "Group C");
            dt.Rows.Add(15, "Value 15", "Group C");
            dt.Rows.Add(16, "Value 16", "Group C");
            c1TileControl1.DataSource = dt;

            //Populate ComboBox with Colors
            foreach (System.Reflection.PropertyInfo col in typeof(Color).GetProperties())
            {
                if (col.PropertyType.FullName == "System.Drawing.Color")
                {
                    CB_TileColor.Items.Add(col.Name);
                }
            }
            c1TileControl1.TileBackColor = Color.SeaGreen;
        }

        private void c1TileControl1_CompareGroups(object sender, CompareGroupsEventArgs e)
        {
            //To sort groups in reversed order
            e.Result = -String.Compare(e.Group1.Text, e.Group2.Text);
        }

        private void c1TileControl1_CompareTiles(object sender, CompareTilesEventArgs e)
        {
            //To sort tiles in reversed order
            e.Result = -(e.Tile1.IntValue - e.Tile2.IntValue);
        }
    }
}
